/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

import { SBrush, SPoint } from "./../src"
import { SBrushType } from "./../src/enums/SBrushType";
import { SColor, SLinearGradient } from "./../src/";
import expect from "expect"

/**
 * 画刷测试
 *
 * @author 韩耀龙 han_yao_long@163.com
 */

test("构造函数", () => {
    // 无参数
    let brush = new SBrush();
    expect(brush).toStrictEqual(new SBrush());

    // 第一个参数
    let brush1 = new SBrush(brush);
    expect(brush1).toStrictEqual(new SBrush());

    let linearGradient = new SLinearGradient(new SPoint(0,0),new SPoint(1,1))
    let brush2 = new SBrush(linearGradient);
    expect(brush2.type).toBe(SBrushType.Gradient);

    let color = new SColor('#ffffff')
    let brush3 = new SBrush(color);
    expect(brush3.type).toBe(SBrushType.Color);

});

test("设置属性", () => {
    let brush = new SBrush();
    brush.color = new SColor('#ffffff');
    expect(brush.color).toStrictEqual(new SColor('#ffffff'));

    let brush1 = new SBrush();
    brush1.gradient = new SLinearGradient(new SPoint(0,0),new SPoint(1,1))
    expect(brush1.gradient).toStrictEqual(new SLinearGradient(new SPoint(0,0),new SPoint(1,1)));

});
