/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

import { SColor } from "./../src/";
import expect from "expect"

/**
 * 颜色测试
 *
 * @author 韩耀龙 han_yao_long@163.com
 */

test("构造函数", () => {
    let color = new SColor();
    expect(color.toVal()).toBe('#000000');

    let color1 = new SColor('#ffffff');
    expect(color1.toVal()).toBe('#ffffff');

    let color2 = new SColor(113, 168, 28);
    expect(color2.toVal()).toBe('#71a81c');
    let color3 = new SColor(color2);
    expect(color3.toVal()).toBe('#71a81c');

    let color4 = new SColor(113, 168, 28, 255);
    expect(color4.toVal()).toBe('#71a81c');
});

test("获取属性", () => {
    let color = new SColor('#71a81c');
    expect(color.toRgb()).toBe('rgb(113, 168, 28)');
    expect(color.toRgba()).toBe('rgba(113, 168, 28, 1)');
    expect(color.toVal()).toBe('#71a81c')
});

test("设置属性", () => {
    let color = new SColor('#71a81c');
    color.red = 50;
    expect(color.toVal()).toBe('#32a81c');

    let color1 = new SColor('#71a81c');
    color1.green = 50;
    expect(color1.toVal()).toBe('#71321c');

    let color3 = new SColor('#71a81c');
    color3.blue = 50;
    expect(color3.toVal()).toBe('#71a832');

    let color4 = new SColor('#71a81c');
    color4.alpha = 255;
    expect(color4.toVal()).toBe('#71a81c');

    let color5 = new SColor('#71a81c');
    color5.value = '#32a81cff';
    expect(color5.toVal()).toBe('#32a81c');

    let color6 = new SColor('#71a81c');
    color6.value = 'f';
    expect(color6.toVal()).toBe('#71a81c');

    expect(SColor.rgb(113,168,50)).toStrictEqual(new SColor('#71a832ff'))

    expect(SColor.rgba(113,168,50,255)).toStrictEqual(new SColor('#71a832ff'));


    expect(SColor.rgb(113,168,50)).toStrictEqual(new SColor('#71a832ff'))

    expect(SColor.rgba(113,168,50,255)).toStrictEqual(new SColor('#71a832ff'));
});
