import { SPoint } from "../../src";
import { SLine } from "../../src";
import expect from "expect"
test("构造函数", () => {
    // 无参数
    let line = new SLine()
    expect(line.p1).toStrictEqual(new SPoint(0, 0));
    expect(line.p2).toStrictEqual(new SPoint(0, 0));

    // 一个参数
    let line1 = new SLine(line)
    expect(line1.p1).toStrictEqual(new SPoint(0, 0));
    expect(line1.p2).toStrictEqual(new SPoint(0, 0));
    // 两个参数
    let p1 = new SPoint(1, 2);
    let p2 = new SPoint(2, 4);
    let line2 = new SLine(p1,p2)
    expect(line2.p1).toStrictEqual(p1);
    expect(line2.p2).toStrictEqual(p2);

    // 四个参数
    let line3 = new SLine(0,0,2,2)
    expect(line3.x1).toBe(0);
    expect(line3.x2).toBe(2);
    expect(line3.y1).toBe(0);
    expect(line3.y2).toBe(2);
});


test("设置属性", () => {
    let line = new SLine();
    line.x1 = 1;
    expect(line.x1).toBe(1);

    line.y1 = 1;
    expect(line.y1).toBe(1);

    line.x2 = 1;
    expect(line.x2).toBe(1);

    line.y2 = 1;
    expect(line.y2).toBe(1);

    expect(line.dx).toBe(0);
    expect(line.dy).toBe(0);

});

test("isNull", () => {
    // 答案为 true
    let line = new SLine();
    expect(line.isNull()).toBeTruthy();
    // 答案为 false
    let line1 = new SLine(0,0,1,1);
    expect(line1.isNull()).toBeFalsy();
});

test("center", () => {
    let line = new SLine(0,0,2,2);
    expect(line.center()).toStrictEqual(new SPoint(1,1));
});

test("translated", () => {
    let line = new SLine(0,0,2,2);

    expect(line.translated(2,2)).toStrictEqual(new SLine(2,2,4,4));
});

test("translate", () => {
    let line = new SLine(0,0,2,2);
    line.translate(2,2)
    expect(line.x1).toBe(2);
    expect(line.y1).toBe(2);
    expect(line.x2).toBe(4);
    expect(line.y2).toBe(4);
});