/*
 * *********************************************************************************************************************
 *
 *          !!
 *        .F88X
 *        X8888Y
 *      .}888888N;
 *        i888888N;        .:!              .I$WI:
 *          R888888I      .'N88~            i8}+8Y&8"l8i$8>8W~'>W8}8]KW+8IIN"8&
 *          .R888888I    .;N8888~          .X8'  "8I.!,/8"  !%NY8`"8I8~~8>,88I
 *            +888888N;  .8888888Y                                  "&&8Y.}8,
 *            ./888888N;  .R888888Y        .'}~    .>}'.`+>  i}!    "i'  +/'  .'i~  !11,.:">,  .~]!  .i}i
 *              ~888888%:  .I888888l      .]88~`1/iY88Ii+1'.R$8$8]"888888888>  Y8$  W8E  X8E  W8888'188Il}Y88$*
 *              18888888    E8888881    .]W%8$`R8X'&8%++N8i,8N%N8+l8%`  .}8N:.R$RE%N88N%N$K$R  188,FE$8%~Y88I
 *            .E888888I  .i8888888'      .:$8I;88+`E8R:/8N,.>881.`$8E/1/]N8X.Y8N`"KF&&FK!'88*."88K./$88%RN888+~
 *            8888888I  .,N888888~        ~88i"8W,!N8*.I88.}888%F,i$88"F88"  888:E8X.>88!i88>`888*.}Fl1]*}1YKi'
 *          i888888N'      I888Y          ]88;/EX*IFKFK88X  K8R  .l8W  88Y  ~88}'88E&%8W.X8N``]88!.$8K  .:W8I
 *        .i888888N;        I8Y          .&8$  .X88!  i881.:%888>I88  ;88]  +88+.';;;;:.Y88X  18N.,88l  .+88/
 *      .:R888888I
 *      .&888888I                                          Copyright (c) 2009-2020.  博锐尚格科技股份有限公司
 *        ~8888'
 *        .!88~                                                                     All rights reserved.
 *
 * *********************************************************************************************************************
 */

import { SSize,SAspectRatioMode } from "../../src";
import expect from "expect"

/**
 * 矩形测试
 *
 * @author 韩耀龙 han_yao_long@163.com
 */

test("构造函数", () => {

    // 无参数
    let size = new SSize()
    expect(size.width).toBe(0);
    expect(size.height).toBe(0);

    // 一个参数
    let size1 = new SSize(1,1)
    let size2 = new SSize(size1)
    expect(size2.width).toBe(1);
    expect(size2.height).toBe(1);

    // 两个参数

    let size3 = new SSize(3,3)
    expect(size3.width).toBe(3);
    expect(size3.height).toBe(3);
});


test("isEmpty", () => {
    // true
    let size = new SSize()
    expect(size.isEmpty()).toBeTruthy();
    // false
    let size1 = new SSize(4, 4)
    expect(size1.isEmpty()).toBeFalsy();
});


test("isNull", () => {
    // true
    let size = new SSize()
    expect(size.isNull()).toBeTruthy();
    // false
    let size1 = new SSize(4, 4)
    expect(size1.isNull()).toBeFalsy();
});

test("isValid", () => {
    // true
    let size = new SSize()
    expect(size.isValid()).toBeFalsy();
    // false
    let size1 = new SSize(4, 4)
    expect(size1.isValid()).toBeTruthy();
});

test("scale", () => {
    let size1 = new SSize(4, 4);
    size1.scale(2,2)
    expect(size1.width).toBe(2);
    expect(size1.height).toBe(2);

    let size2 = new SSize(4, 4);
    size2.scale(1,2,SAspectRatioMode.KeepAspectRatio);
    expect(size2.width).toBe(1);
    expect(size2.height).toBe(1);

    let size3 = new SSize(4, 4);
    size3.scale(1,2,SAspectRatioMode.KeepAspectRatioByExpanding);
    expect(size3.width).toBe(2);
    expect(size3.height).toBe(2);
});

test("scaled", () => {
    let size1 = new SSize(4, 4);
    let size3 = size1.scaled(2,2)
    expect(size3.width).toBe(2);
    expect(size3.height).toBe(2);

    let size4 = new SSize(1, 2);
    const size5 = size4.scaled(2,2,SAspectRatioMode.KeepAspectRatio);
    expect(size5.width).toBe(1);
    expect(size5.height).toBe(2);

    let size6 = new SSize(1, 2);
    const size7 = size6.scaled(2,2,SAspectRatioMode.KeepAspectRatioByExpanding);
    expect(size7.width).toBe(2);
    expect(size7.height).toBe(4);

});

test("transpose", () => {
    let size1 = new SSize(2, 4);
    size1.transpose()
    expect(size1.width).toBe(4);
    expect(size1.height).toBe(2);
});

test("transposed", () => {
    let size1 = new SSize(2, 4);
    const size2 = size1.transposed()
    expect(size2.width).toBe(4);
    expect(size2.height).toBe(2);
});
